︠3a903efc-838e-4592-9490-635a2cb72fe1︠
%sage
# Markdown mode for Maxima
def maxima_md(s):
    import re
    #print s
    # insert calls to tex around expressions separated by $ or ; or as a single expression per line
    s=re.compile(r'((?:(?![\n\$;]).)+)([\$;\n]?)',re.M+re.S).sub(r'tex(\1,false)\2',s,count=0)
    #print s
    t = maxima.eval(s,split_lines=true, reformat=false)
    # cleanup generated LaTeX for MathJax
    t=re.compile(r'\$\$').sub('\n$$\n',t,count=0)
    t=re.compile(r'\\\\').sub(r'\\',t,count=0)
    t=re.compile(r'\\cos').sub(r'\\mathrm{cos}',t,count=0)
    t=re.compile(r'\\sin').sub(r'\\mathrm{sin}',t,count=0)
    t=re.compile(r'\\_').sub(r'_',t,count=0)
    t=re.compile(r'\\begin{verbatim}').sub(r'$$',t,count=0)
    t=re.compile(r'\\end{verbatim}').sub(r'$$',t,count=0)
    # strip non-escaped string quotes
    t=re.compile(r'[^\\]"([^"]*?)').sub(r'\1',t,count=0)
    # remove escape chars before quotes
    t=re.compile(r'\\"').sub('"',t,count=0)
    # Maybe this just text output? Indent as a preformatted code block
    t=re.compile(r'\n\s*([^\$].*)').sub(r'    \1',t,count=0)
    # hide input and output numbers (Sage makes it impossible to use them anyway.)
    t=re.compile(r'\(\%o[0-9]+\)').sub(r'',t)
    t=re.compile(r'\(\%i[0-9]+\) ').sub(r'',t)
    #print "'",t,"'"
    md(t, hide=False)
%default_mode maxima_md
︡a904820d-3370-49a8-b7f8-6e09ce81477a︡
︠9bfbe959-dc5b-41c4-9a3b-51f5028efb4d︠
x * y * z; x+1; y^2
z^3
︡b3822db2-435a-4062-90aa-abddb7e2f314︡{"md":"\r    \n$$    x\\,y\\,z\n$$    \n$$    x+1\n$$    \n$$    y^2\n$$    \n$$    z^3\n$$    \n"}︡
︠7524c9b3-69a3-420a-9bc1-2fcf7a1c337f︠
diff(sqrt(sin(x^2)),x)
︡ddde0d7d-2905-4f81-a891-6711f2285d43︡{"md":"\r    \n$$    {{x\\,\\mathrm{cos} x^2}\\over{\\sqrt{\\mathrm{sin} x^2}}}\n$$    \n"}︡
︠ab18fa6d-7078-47e9-8e62-8f89b6099d6b︠
integrate (1/(1+x^3), x)
︡903e03b0-d31f-4408-a362-41cd69a51101︡{"md":"\r    \n$$    -{{\\log \\left(x^2-x+1\\right)}\\over{6}}+{{\\arctan \\left({{2\\,x-1\r    }\\over{\\sqrt{3}}}\\right)}\\over{\\sqrt{3}}}+{{\\log \\left(x+1\\right)\r    }\\over{3}}\n$$    \n"}︡
︠e9a522fe-9946-4dd9-af1a-cb1322c424f5︠
texput(me,"\\mu_e")
︡6e7fccce-e884-4414-99cc-e4f6e0b4e053︡{"md":"\r    \n$$    \\mu_e\n$$    \n"}︡
︠3c812155-ee40-444b-9075-7f7012ff44fa︠
me+1
me+2
︡66f8bcf0-9df3-4f2a-b121-4d28501b6721︡{"md":"\r    \n$$    \\mu_e+1\n$$    \n$$    \\mu_e+2\n$$    \n"}︡
︠0106b0f6-e6c7-46e8-954b-6c8826bb2261︠
ev(%e,numer)
︡78650a3f-4d38-4dbc-a0c8-d1d773147008︡{"md":"\r    \n$$    2.718281828459045\n$$    \n"}︡
︠7373f404-6c4a-4bd4-8732-deb06b9e9223︠
a:1
︡3be29397-ac91-45e2-9c3d-54f46a8f524f︡{"md":"\r    \n$$    1\n$$    \n"}︡
︠da96a5ca-b36e-4782-8450-339e8650a3bd︠
a
︡e4e6c265-a3cb-4cf8-8a12-c43a226f5b5e︡{"md":"\r    \n$$    1\n$$    \n"}︡
︠9749b2ab-bd55-4979-a70f-7774a8413844︠
f(x):= x^2 -x + 1
︡c8b96f37-0e68-4714-8bd5-1db80accd431︡{"md":"\r    \r\n$$\r    f(x):=1-x+x^2;\r\n$$\r    \n"}︡
︠e1a24b68-2dc2-448c-bee2-3eab7dfa1f16︠
f(3)
︡ae5c0fde-7ad4-42b5-b46c-fd654538767d︡{"md":"\r    \n$$    7\n$$    \n"}︡
︠cb884b29-13f7-430a-8c0e-920b9af17196︠
factor(30!)
︡5baa7358-6835-47eb-99a2-7242296afcec︡{"md":"\r    \n$$    2^{26}\\,3^{14}\\,5^7\\,7^4\\,11^2\\,13^2\\,17\\,19\\,23\\,29\n$$    \n"}︡
︠142cfa03-96b5-43d0-af7b-4883bdc3ea33︠
s:solve(x^3=1,x)
s[1]
︡05e6ea1b-8c2c-4100-ae16-a74e5b16e005︡{"md":"\r    \n$$    \\left[ x={{\\sqrt{3}\\,i-1}\\over{2}} , x=-{{\\sqrt{3}\\,i+1}\\over{2}}\r    , x=1 \\right] \n$$    \n$$    x={{\\sqrt{3}\\,i-1}\\over{2}}\n$$    \n"}︡
︠4e328659-d41e-47bc-a5f9-79de9831b14d︠
ev(sum(k, k, 1, n), simpsum)
︡8efdd52a-e1f6-4483-ac4e-6a96f4992c0a︡{"md":"\r    \n$$    {{n^2+n}\\over{2}}\n$$    \n"}︡
︠9c9d380b-3722-4e7b-bc85-2c55a3baa944︠
'diff (y, x, 2) + 'diff (y, x) + y
︡af58bd1c-29df-45e6-be0d-8ece34d3d9e8︡{"md":"\r    \n$$    {{{\\it \\partial}^2}\\over{{\\it \\partial}\\,x^2}}\\,y+{{{\\it \\partial}\r    }\\over{{\\it \\partial}\\,x}}\\,y+y\n$$    \n"}︡
︠b96d50a3-e15b-434e-bdb3-d7b01a40b751︠
m:matrix([1,2],[3,4])
︡f3832ece-f809-4f93-a8df-4794bf5a5fd0︡{"md":"\r    \n$$    \\pmatrix{1&2\\cr 3&4\\cr }\n$$    \n"}︡
︠f9960090-15ba-4248-8bdb-c759f4a45c08︠
m^2
︡93e622f6-835a-41ca-881e-1b0489389d6b︡{"md":"\r    \n$$    \\pmatrix{1&4\\cr 9&16\\cr }\n$$    \n"}︡
︠c482aca4-322e-4a55-9713-874ea7f359d4︠
eigenvectors (m)
︡f69eed2d-bd79-4848-a241-eff7af193428︡{"md":"\r    \n$$    \\left[ \\left[ \\left[ -{{\\sqrt{33}-5}\\over{2}} , {{\\sqrt{33}+5\r    }\\over{2}} \\right]  , \\left[ 1 , 1 \\right]  \\right]  , \\left[ \r    \\left[ \\left[ 1 , -{{\\sqrt{33}-3}\\over{4}} \\right]  \\right]  , \r    \\left[ \\left[ 1 , {{\\sqrt{33}+3}\\over{4}} \\right]  \\right]  \\right] \r    \\right] \n$$    \n"}︡
︠8ad5fb01-ec37-4bb4-9bfe-645f8ce1c817︠
batch ("critpts.max")
︡1eb9348c-510a-494f-b4e9-b086852dfa71︡{"md":"\r    \r    read and interpret file: /projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/critpts.max\r    critpts(f):=(print(\"program to find critical points\"),newline(),\r    print(\" f = \",f),eqs:[diff(f,x),diff(f,y)],unk:[x,y],\r    solve(eqs,unk))\r    \n$$    \\mbox{ critpts.max }\n$$    \n"}︡
︠7d477c1b-0493-4bf8-9ccd-acfc1acd284c︠
critpts ((y+x)*%e^(y^2+x^3))
︡634d17dc-9157-410b-bf14-93a89fbadb6f︡{"md":"\r    program to find critical points \r    f =  (y+x)*%e^(y^2+x^3) \r    \n$$    \\left[ \\left[ x=0.4588955685487001\\,i+0.3589790871086935 , y=\r    0.4942017368275118\\,i-0.1225787367783657 \\right]  , \\left[ x=\r    0.3589790871086935-0.4588955685487001\\,i , y=-0.4942017368275118\\,i-\r    0.1225787367783657 \\right]  , \\left[ x=0.4187542327234816\\,i-\r    0.6923124204420268 , y=0.455912070111699-0.8697262692814121\\,i\r    \\right]  , \\left[ x=-0.4187542327234816\\,i-0.6923124204420268 , y=\r    0.8697262692814121\\,i+0.455912070111699 \\right]  \\right] \n$$    \n"}︡
︠de325693-f13d-4801-9a0a-6e930d7b9d21i︠
%md computes $\sqrt{10}$
︡e0d4e1a9-a3da-43df-8b85-2f043ea437bc︡{"md":"computes $\\sqrt{10}$"}︡
︠7cb00edd-89f6-489d-9eef-d0d5a0467644︠
w: 1.$
r:for n: 1 thru 10 do (w0: w, w: .5*(w + 10./w), if w = w0 then return(w));
r^2
︡31745b79-53f6-4436-902d-e100550efcfa︡{"md":"\r    \n$$    3.162277660168379\n$$    \n$$    9.999999999999998\n$$    \n"}︡
︠545f9652-99dd-462c-ab81-6c326ae75d54︠
assume (b > 0)$
integrate (1/(1 + x), x, 0, b)
︡b64b8f5b-c951-40c4-abb3-a29823b03fa5︡{"md":"\r    \n$$    \\log \\left(b+1\\right)\n$$    \n"}︡
︠0f8fb9aa-fbab-4ea7-a9fa-86d18ab8c6cb︠
eqn: 'diff(x,t,2) + r*'diff(x,t)^2 = 0
sol: ode2(eqn, x, t)
︡81088d85-8159-4e01-a343-8edef6170047︡{"md":"\r    \n$$    {{{\\it \\partial}^2}\\over{{\\it \\partial}\\,t^2}}\\,x+3.162277660168379\r    \\,\\left({{{\\it \\partial}}\\over{{\\it \\partial}\\,t}}\\,x\\right)^2=0\n$$    \r    rat: replaced 3.162277660168379 by 39480499/12484830 = 3.16227766016838\r    \n$$    x={{12484830\\,\\log \\left(39480499\\,t+39480499\\,{\\it \\%k_1}\\right)\r    }\\over{39480499}}+{\\it \\%k_2}\n$$    \n"}︡
︠ce0f96cc-26a2-45bb-9451-877d53ccf3fe︠
describe(integrate)
︡5c991c05-9d25-42d7-8923-414b5790b312︡{"md":"\r    \r    -- Function: integrate\r    integrate (<expr>, <x>)\r    integrate (<expr>, <x>, <a>, <b>)\r    Attempts to symbolically compute the integral of <expr> with\r    respect to <x>.  'integrate (<expr>, <x>)' is an indefinite\r    integral, while 'integrate (<expr>, <x>, <a>, <b>)' is a definite\r    integral, with limits of integration <a> and <b>.  The limits\r    should not contain <x>, although 'integrate' does not enforce this\r    restriction.  <a> need not be less than <b>.  If <b> is equal to\r    <a>, 'integrate' returns zero.\r    See 'quad_qag' and related functions for numerical approximation of\r    definite integrals.  See 'residue' for computation of residues\r    (complex integration).  See 'antid' for an alternative means of\r    computing indefinite integrals.\r    The integral (an expression free of 'integrate') is returned if\r    'integrate' succeeds.  Otherwise the return value is the noun form\r    of the integral (the quoted operator ''integrate') or an expression\r    containing one or more noun forms.  The noun form of 'integrate' is\r    displayed with an integral sign.\r    In some circumstances it is useful to construct a noun form by\r    hand, by quoting 'integrate' with a single quote, e.g., ''integrate\r    (<expr>, <x>)'.  For example, the integral may depend on some\r    parameters which are not yet computed.  The noun may be applied to\r    its arguments by 'ev (<i>, nouns)' where <i> is the noun form of\r    interest.\r    'integrate' handles definite integrals separately from indefinite,\r    and employs a range of heuristics to handle each case.  Special\r    cases of definite integrals include limits of integration equal to\r    zero or infinity ('inf' or 'minf'), trigonometric functions with\r    limits of integration equal to zero and '%pi' or '2 %pi', rational\r    functions, integrals related to the definitions of the 'beta' and\r    'psi' functions, and some logarithmic and trigonometric integrals.\r    Processing rational functions may include computation of residues.\r    If an applicable special case is not found, an attempt will be made\r    to compute the indefinite integral and evaluate it at the limits of\r    integration.  This may include taking a limit as a limit of\r    integration goes to infinity or negative infinity; see also\r    'ldefint'.\r    Special cases of indefinite integrals include trigonometric\r    functions, exponential and logarithmic functions, and rational\r    functions.  'integrate' may also make use of a short table of\r    elementary integrals.\r    'integrate' may carry out a change of variable if the integrand has\r    the form 'f(g(x)) * diff(g(x), x)'.  'integrate' attempts to find a\r    subexpression 'g(x)' such that the derivative of 'g(x)' divides the\r    integrand.  This search may make use of derivatives defined by the\r    'gradef' function.  See also 'changevar' and 'antid'.\r    If none of the preceding heuristics find the indefinite integral,\r    the Risch algorithm is executed.  The flag 'risch' may be set as an\r    'evflag', in a call to 'ev' or on the command line, e.g., 'ev\r    (integrate (<expr>, <x>), risch)' or 'integrate (<expr>, <x>),\r    risch'.  If 'risch' is present, 'integrate' calls the 'risch'\r    function without attempting heuristics first.  See also 'risch'.\r    'integrate' works only with functional relations represented\r    explicitly with the 'f(x)' notation.  'integrate' does not respect\r    implicit dependencies established by the 'depends' function.\r    'integrate' may need to know some property of a parameter in the\r    integrand.  'integrate' will first consult the 'assume' database,\r    and, if the variable of interest is not there, 'integrate' will ask\r    the user.  Depending on the question, suitable responses are 'yes;'\r    or 'no;', or 'pos;', 'zero;', or 'neg;'.\r    'integrate' is not, by default, declared to be linear.  See\r    'declare' and 'linear'.\r    'integrate' attempts integration by parts only in a few special\r    cases.\r    Examples:\r    * Elementary indefinite and definite integrals.\r    integrate (sin(x)^3, x);\r    3\r    cos (x)\r                       ------- - cos(x)\r    3\r    integrate (x/ sqrt (b^2 - x^2), x);\r    2    2\r                        - sqrt(b  - x )\r    integrate (cos(x)^2 * exp(x), x, 0, %pi);\r    %pi\r    3 %e      3\r                          ------- - -\r    5      5\r    integrate (x^2 * exp(-x^2), x, minf, inf);\r    sqrt(%pi)\r                           ---------\r    2\r    * Use of 'assume' and interactive query.\r    assume (a > 1)$\r    integrate (x**a/(x+1)**(5/2), x, 0, inf);\r    2 a + 2\r    Is  -------  an integer?\r    5\r    no;\r    Is  2 a - 3  positive, negative, or zero?\r    neg;\r    3\r                      beta(a + 1, - - a)\r    2\r    * Change of variable.  There are two changes of variable in this\r    example: one using a derivative established by 'gradef', and\r    one using the derivation 'diff(r(x))' of an unspecified\r    function 'r(x)'.\r    gradef (q(x), sin(x**2));\r                             q(x)\r    diff (log (q (r (x))), x);\r    d               2\r    (-- (r(x))) sin(r (x))\r    dx\r                    ----------------------\r    q(r(x))\r    integrate (%, x);\r                         log(q(r(x)))\r    * Return value contains the ''integrate' noun form.  In this\r    example, Maxima can extract one factor of the denominator of a\r    rational function, but cannot factor the remainder or\r    otherwise find its integral.  'grind' shows the noun form\r    ''integrate' in the result.  See also 'integrate_use_rootsof'\r    for more on integrals of rational functions.\r    expand ((x-4) * (x^3+2*x+1));\r    4      3      2\r                  x  - 4 x  + 2 x  - 7 x - 4\r    integrate (1/%, x);\r    /  2\r    [ x  + 4 x + 18\r    I ------------- dx\r    ]  3\r    log(x - 4)   / x  + 2 x + 1\r                ---------- - ------------------\r    73               73\r    grind (%);\r    log(x-4)/73-('integrate((x^2+4*x+18)/(x^3+2*x+1),x))/73$\r    * Defining a function in terms of an integral.  The body of a\r    function is not evaluated when the function is defined.  Thus\r    the body of 'f_1' in this example contains the noun form of\r    'integrate'.  The quote-quote operator '''' causes the\r    integral to be evaluated, and the result becomes the body of\r    'f_2'.\r    f_1 (a) := integrate (x^3, x, 1, a);\r    3\r               f_1(a) := integrate(x , x, 1, a)\r    ev (f_1 (7), nouns);\r                              600\r    /* Note parentheses around integrate(...) here */\r    f_2 (a) := ''(integrate (x^3, x, 1, a));\r    4\r    a    1\r                       f_2(a) := -- - -\r    4    4\r    f_2 (7);\r                              600\r    There are also some inexact matches for `integrate'.\r    Try `?? integrate' to see them.\r    \n$$    \\mathbf{true}\n$$    \n"}︡
︠be0592c5-0a84-4d08-a8e2-b0e0387e3ce9︠









